! 
! File:          ExceptionTest_Fib_Impl.F90
! Symbol:        ExceptionTest.Fib-v1.0
! Symbol Type:   class
! Babel Version: 0.8.0
! Description:   Server-side implementation for ExceptionTest.Fib
! 
! WARNING: Automatically generated; only changes within splicers preserved
! 
! babel-version = 0.8.0
! 


! 
! Symbol "ExceptionTest.Fib" (version 1.0)
! 
! This class holds the method <code>getFib</code> that generates the
! requested Fibonacci numbers.
! 


#include "ExceptionTest_FibException_fAbbrev.h"
#include "SIDL_BaseInterface_fAbbrev.h"
#include "SIDL_BaseClass_fAbbrev.h"
#include "SIDL_ClassInfo_fAbbrev.h"
#include "ExceptionTest_Fib_fAbbrev.h"
#include "ExceptionTest_NegativeValueException_fAbbrev.h"
! DO-NOT-DELETE splicer.begin(_miscellaneous_code_start)
#include "ExceptionTest_TooBigException_fAbbrev.h"
#include "ExceptionTest_TooDeepException_fAbbrev.h"
! DO-NOT-DELETE splicer.end(_miscellaneous_code_start)




! 
! Class constructor called when the class is created.
! 

subroutine ExceptionTest_Fib__ctor_mi(self)
  ! DO-NOT-DELETE splicer.begin(ExceptionTest.Fib._ctor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(ExceptionTest.Fib._ctor.use)
  implicit none
  integer (selected_int_kind(18)) :: self

! DO-NOT-DELETE splicer.begin(ExceptionTest.Fib._ctor)
! Nothing needed here...
! DO-NOT-DELETE splicer.end(ExceptionTest.Fib._ctor)
end subroutine ExceptionTest_Fib__ctor_mi


! 
! Class destructor called when the class is deleted.
! 

subroutine ExceptionTest_Fib__dtor_mi(self)
  ! DO-NOT-DELETE splicer.begin(ExceptionTest.Fib._dtor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(ExceptionTest.Fib._dtor.use)
  implicit none
  integer (selected_int_kind(18)) :: self

! DO-NOT-DELETE splicer.begin(ExceptionTest.Fib._dtor)
! Nothing needed here...
! DO-NOT-DELETE splicer.end(ExceptionTest.Fib._dtor)
end subroutine ExceptionTest_Fib__dtor_mi


! 
! <p>
! Generate the requested Fibonacci number or generate exceptions if
! the input Fibonacci number is invalid or if any of the maximum depth
! or maximum value parameters are exceeded.  The last argument of the
! method should be zero.
! </p>
! <p>
! The logic method should be similar to the following <code>Java</code>:
! </p>
! <pre>
! public int getFib(int n, int max_depth, int max_value, int depth)
!     throws NegativeValueException, FibException {
! 
!   if (n &lt; 0) {
!     throw new NegativeValueException("n negative");
! 
!   } else if (depth &gt; max_depth) {
!     throw new TooDeepException("too deep");
! 
!   } else if (n == 0) {
!     return 1;
! 
!   } else if (n == 1) {
!     return 1;
! 
!   } else {
!     int a = getFib(n-1, max_depth, max_value, depth+1);
!     int b = getFib(n-2, max_depth, max_value, depth+1);
!     if (a + b &gt; max_value) {
!       throw new TooBigException("too big");
!     }
!     return a + b;
!   }
! } 
! </pre>
! 

subroutine ExceptionTest_Fib_getFib_mi(self, n, max_depth, max_value, depth,   &
  retval, exception)
  ! DO-NOT-DELETE splicer.begin(ExceptionTest.Fib.getFib.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(ExceptionTest.Fib.getFib.use)
  implicit none
  integer (selected_int_kind(18)) :: self
  integer (selected_int_kind(9)) :: n
  integer (selected_int_kind(9)) :: max_depth
  integer (selected_int_kind(9)) :: max_value
  integer (selected_int_kind(9)) :: depth
  integer (selected_int_kind(9)) :: retval
  integer (selected_int_kind(18)) :: exception

! DO-NOT-DELETE splicer.begin(ExceptionTest.Fib.getFib)
  character*(*) myfilename 
  parameter(myfilename='ExceptionTest_Fib_Impl.f')
  integer*4 a, b
  retval = 0
  if (n .lt. 0) then
     call ExceptionTest_NegativeValueException__create_m(exception)
     if (exception .ne. 0) then
        call ExceptionTest_NegativeValueException_setNote_m(exception, &
             'called with negative n')
        call ExceptionTest_NegativeValueException_add_m( &
             exception, myfilename, 57, 'ExceptionTest_Fib_getFib_impl')
        return
     endif
  else if (depth .gt. max_depth) then
     call ExceptionTest_TooDeepException__create_m(exception)
     if (exception .ne. 0) then
        call ExceptionTest_TooDeepException_setNote_m( exception, &
             'exceeded specified recursion depth')
        call ExceptionTest_TooDeepException_add_m( exception, &
             myfilename, 70, 'ExceptionTest_Fib_getFib_impl')
        return
     endif
  else if (n .eq. 0) then
     retval = 1
  else if (n .eq. 1) then
     retval = 1
  else 
   ! 
   ! Note that we must call the stub version of this method
   ! because g77 does not (currently) support recursion.
   ! 
     call ExceptionTest_Fib_getFib_m(self, &
          n-1, &
          max_depth, & 
          max_value, &
          depth+1, & 
          a, &
          exception)
     if (exception .ne. 0) then
        call SIDL_BaseException_add_m( &
             exception, &
             myfilename, &
             90, &
             'ExceptionTest_Fib_getFib_impl')
        return
     endif
   ! 
   ! Note that we must call the stub version of this method
   ! because g77 does not (currently) support recursion.
   ! 
     call ExceptionTest_Fib_getFib_m(self, &
          n-2, &
          max_depth, &
          max_value, &
          depth+1, &
          b, &
          exception)
     if (exception .ne. 0) then
        call SIDL_BaseException_add_m( &
             exception, &
             myfilename, &
             105,  &
             'ExceptionTest_Fib_getFib_impl')
        return
     endif
     retval = a+b
     if (retval .gt. max_value) then
        retval = 0
        call ExceptionTest_TooBigException__create_m(exception)
        if (exception .ne. 0) then
           call ExceptionTest_TooBigException_setNote_m( &
                exception, &
                'result exceeds specified maximum value')
           call ExceptionTest_TooBigException_add_m( &
                exception, &
                myfilename, &
                103, &
                'ExceptionTest_Fib_getFib_impl')
           return
        endif
     endif
  endif
! DO-NOT-DELETE splicer.end(ExceptionTest.Fib.getFib)
end subroutine ExceptionTest_Fib_getFib_mi


! DO-NOT-DELETE splicer.begin(_miscellaneous_code_end)
! Nothing needed here...
! DO-NOT-DELETE splicer.end(_miscellaneous_code_end)
