#
# Copyright(c) 2002, The Regents of the University of California.
# Produced at the Lawrence Livermore National Laboratory.
# Written by Gary Kumfert <kumfert@llnl.gov>.
# UCRL-CODE-2002-043.
# All rights reserved.
#
# This file is part of Gauntlet.  For details, see 
# http://www.llnl.gov/CASC/components/software.html or contact the author.
#
# Gauntlet is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License (as published by 
# the Free Software Foundation) version 2.1 dated February 1999.
#
# Gauntlet is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even IMPLIED WARRANTY OF MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the terms and conditions of
# the GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this software; if not, write to the Free Software Foundation, 
# Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# ADDITIONAL NOTICE:
# 
# A. This notice is required to be provided under our contract with the
#    U.S. Department of Energy (DOE).  This work was produced at the 
#    University of California, Lawrence Livermore National Laboratory
#    under Contract No. W-7405-ENG-48 with the DOE.
#
# B. Neither the United States Government nor the University of California
#    nor any of their employees make any warranty, express or implied, or
#    assumes any liability or responsibility for the accuracy, completeness, 
#    or usefulness of any information, apparatus, product, or process 
#    disclosed, or represents that its use would not infringe on 
#    privately-owned rights.
# 
# C. Also, reference herein to any specific commercial products, process, or
#    services by trade name, trademark, manufacturer or otherwise does not
#    necessarily constitute or imply its endoresement, recommendation, or
#    favoring by the United States Government or the University of California.
#    The views and opinions of authors expressed herein do not necessarily 
#    state or reflect those of the United States Government or the University
#    of California, and shall not be used for advertising or product 
#    endorsement purposes.
"""
Configuration Module for Gauntlet
"""

import os

# set this to higher numbers for more debugging information to
# be printed
verbose = 0

# set this to other directories for VPATH builds
#
srcdir = os.curdir

# set addtional switches to be propagated to 
# the tests
switches = ''

# set a text base name to be passed as the switch
# "--config=%s " %configname
name = '' 

# set as a symbolic name associated with the suite
# e.g. 'ix86-redhat-linux-gcc2.95'
profile='(default)'

# set addtional environment settings before the command
# (e.g. environ='MPIHOSTS=foo/bar '
environ = ''

# set a history file for a summary line to be appended to
# "--histfile=%s " %configname
histfile = ''

# if test to some true value, then GTS will default to exit-status only
#    iff no GTS directives are found in the output (0==pass, 77==xfail, all else == fail)
#
allow_exit_status_only = None

# the maximum recommended linewidth
#
linewidth = 80

# boolean, determines whether or not deprecated syntax 
# should be flagged as a warning
#
warn_deprecated = 1

# string or None, determines file name of XML display
#
xmlout = "gauntlet_archive.xml"

# string or None, determines to whom to send email
# (can be semicolon separated list
email=None

# string, outgoing mail server
#
smtpserver = 'mail-lc.llnl.gov'

# string, pop server for incoming mail
#
popserver = 'poptop.llnl.gov'

# string, account name for popserver
#
popuser = 'babelaut'

# if set to some true value, then the classic display is suppressed
#
quiet = None

# if set to some true value, then the gui progress meter is enabled
#
gui = None

#  if set to 'yes', then given a path to an executable,
#  cd to the directory and then run it from there.  Can be overridden
#  on per-file basis with "GAUNTLET_CD=y" or "GAUNTLET_CD=n" options
#
cd_to_file = 'yes'

