! 
! File:          Ordering_IntOrderTest_Impl.F90
! Symbol:        Ordering.IntOrderTest-v0.1
! Symbol Type:   class
! Babel Version: 0.8.0
! Description:   Server-side implementation for Ordering.IntOrderTest
! 
! WARNING: Automatically generated; only changes within splicers preserved
! 
! babel-version = 0.8.0
! 


! 
! Symbol "Ordering.IntOrderTest" (version 0.1)
! 
! This class provides methods to verify that the array ordering
! capabilities work for arrays of int.
! 


#include "Ordering_IntOrderTest_fAbbrev.h"
#include "SIDL_BaseInterface_fAbbrev.h"
#include "SIDL_BaseClass_fAbbrev.h"
#include "SIDL_ClassInfo_fAbbrev.h"
#include "SIDL_int_fAbbrev.h"
! DO-NOT-DELETE splicer.begin(_miscellaneous_code_start)
integer*4 function iFunc(ind, dim)
  implicit none
  integer*4 dim, ind(dim), result, i
  result = 0
  do i=1, dim
     result = result + i * ind(i)
  enddo
  ifunc = result
end function iFunc

logical function incIndex(ind, A, dimen)
  implicit none
  integer*4 dimen
  integer*4 ind(dimen), i, upper, lower
  integer*8 A
  incIndex = .false.
  i = 1
  do while (i .le. dimen .and. .not. incIndex) 
     call SIDL_int__array_upper_m(A, i - 1, upper)
     ind(i) = ind(i) + 1
     if (ind(i) .gt. upper) then
        call SIDL_int__array_lower_m(A, i - 1, lower)
        ind(i) = lower
        i = i + 1
     else
        incIndex = .true.
     endif
  enddo
end function incIndex

logical function isIMatrix(A)
  implicit none
  integer*8 A
  integer*4 dimen, i, cindex(16), upper
  integer*4 iFunc, elem
  logical incIndex
  call SIDL_int__array_dimen_m(A, dimen)
  isIMatrix = .false.
  if ((dimen .le. 16) .and. (dimen .gt. 0)) then
     do i = 1, dimen
        call SIDL_int__array_lower_m(A, i - 1, cindex(i))
        call SIDL_int__array_upper_m(A, i - 1, upper)
        if (cindex(i) .gt. upper) then
           isIMatrix = .true.
        endif
     enddo
     if (.not. isIMatrix) then
        cindex(1) = cindex(1) - 1
        isIMatrix = .true.
        do while (incIndex(cindex, A, dimen) .and. isIMatrix)
           call SIDL_int__array_get_m(A, cindex, elem)
           if (iFunc(cindex, dimen) .ne. elem) then
              isIMatrix = .false.
           endif
        enddo
     endif
  endif
end function isIMatrix

subroutine fillIMatrix(A)
  implicit none
  integer*8 A
  integer*4 dimen, i, cindex(16), upper, iFunc
  logical incIndex
  if (A .ne. 0) then
     call SIDL_int__array_dimen_m(A, dimen)
     if ((dimen .le. 16) .and. (dimen .gt. 0)) then
        do i = 1, dimen
           call SIDL_int__array_lower_m(A, i - 1, cindex(i))
           call SIDL_int__array_upper_m(A, i - 1, upper)
           if (cindex(i) .gt. upper) then
              return
           endif
        enddo
        cindex(1) = cindex(1) - 1
        do while (incIndex(cindex, A, dimen))
           call SIDL_int__array_set_m(A, cindex, &
                iFunc(cindex, dimen))
        enddo
     endif
  endif
end subroutine fillIMatrix
! DO-NOT-DELETE splicer.end(_miscellaneous_code_start)




! 
! Class constructor called when the class is created.
! 

subroutine Ordering_IntOrderTest__ctor_mi(self)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest._ctor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest._ctor.use)
  implicit none
  integer (selected_int_kind(18)) :: self

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest._ctor)
! Insert the implementation here...
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest._ctor)
end subroutine Ordering_IntOrderTest__ctor_mi


! 
! Class destructor called when the class is deleted.
! 

subroutine Ordering_IntOrderTest__dtor_mi(self)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest._dtor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest._dtor.use)
  implicit none
  integer (selected_int_kind(18)) :: self

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest._dtor)
! Insert the implementation here...
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest._dtor)
end subroutine Ordering_IntOrderTest__dtor_mi


! 
! Create a column-major matrix satisfying condition I.
! 

subroutine makeColumnIMatrixz5ybfavnz3i_mi(size, createCol, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeColumnIMatrix.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeColumnIMatrix.use)
  implicit none
  integer (selected_int_kind(9)) :: size
  logical :: createCol
  integer (selected_int_kind(18)) :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeColumnIMatrix)
  if (createCol) then
     call SIDL_int__array_create2dCol_m(size, size, retval)
  else
     call SIDL_int__array_create2dRow_m(size, size, retval)
  endif
  call fillIMatrix(retval)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeColumnIMatrix)
end subroutine makeColumnIMatrixz5ybfavnz3i_mi


! 
! Create a row-major matrix satisfying condition I.
! 

subroutine In__makeRowIMatrix8h06e37u6x_mi(size, createRow, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeRowIMatrix.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeRowIMatrix.use)
  implicit none
  integer (selected_int_kind(9)) :: size
  logical :: createRow
  integer (selected_int_kind(18)) :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeRowIMatrix)
  if (createRow) then
     call SIDL_int__array_create2dRow_m(size, size, retval)
  else
     call SIDL_int__array_create2dCol_m(size, size, retval)
  endif
  call fillIMatrix(retval)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeRowIMatrix)
end subroutine In__makeRowIMatrix8h06e37u6x_mi


! 
! Create a 4-D matrix satisfying condition I.  Each dimension has
! size elements numbers 0 through size-1.
! 

subroutine IntOr__makeIMatrixs68ixk4nld_mi(size, createColumn, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeIMatrix.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeIMatrix.use)
  implicit none
  integer (selected_int_kind(9)) :: size
  logical :: createColumn
  integer (selected_int_kind(18)) :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeIMatrix)
  integer*4 lower(4), upper(4), i
  do i = 1, 4
     lower(i) = 0
     upper(i) = size - 1
  enddo
  if (createColumn) then
     call SIDL_int__array_createCol_m(4, lower, upper, retval)
  else
     call SIDL_int__array_createRow_m(4, lower, upper, retval)
  endif
  call fillIMatrix(retval)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeIMatrix)
end subroutine IntOr__makeIMatrixs68ixk4nld_mi


! 
! Create a column-major matrix satisfying condition I.
! 

subroutine createColumnIMatrij98n1gtwcu_mi(size, createCol, result)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.createColumnIMatrix.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.createColumnIMatrix.use)
  implicit none
  integer (selected_int_kind(9)) :: size
  logical :: createCol
  integer (selected_int_kind(18)) :: result

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.createColumnIMatrix)
  if (createCol) then
     call Ordering_IntOrderTest_makeColumnIMatrix_m(size, &
          .true., result)
  else
     call Ordering_IntOrderTest_makeRowIMatrix_m(size, &
          .true., result)
  endif
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.createColumnIMatrix)
end subroutine createColumnIMatrij98n1gtwcu_mi


! 
! Create a row-major matrix satisfying condition I.
! 

subroutine __createRowIMatrixq_lpgbci6l_mi(size, createRow, result)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.createRowIMatrix.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.createRowIMatrix.use)
  implicit none
  integer (selected_int_kind(9)) :: size
  logical :: createRow
  integer (selected_int_kind(18)) :: result

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.createRowIMatrix)
  if (createRow) then
     call Ordering_IntOrderTest_makeRowIMatrix_m(size, &
          .true., result)
  else
     call Ordering_IntOrderTest_makeColumnIMatrix_m(size, &
          .true., result)
  endif
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.createRowIMatrix)
end subroutine __createRowIMatrixq_lpgbci6l_mi


! 
! Make sure an array is column-major.  No changes to the dimension or
! values in a are made.
! 

subroutine IntO__ensureColumno2tek0_o3o_mi(a)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.ensureColumn.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.ensureColumn.use)
  implicit none
  integer (selected_int_kind(18)) :: a

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.ensureColumn)
!     no action required
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.ensureColumn)
end subroutine IntO__ensureColumno2tek0_o3o_mi


! 
! Make sure an array is row-major.  No changes to the dimension or
! values in a are made.
! 

subroutine IntOrde__ensureRow2xbnpv1nvt_mi(a)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.ensureRow.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.ensureRow.use)
  implicit none
  integer (selected_int_kind(18)) :: a

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.ensureRow)
!     no action required
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.ensureRow)
end subroutine IntOrde__ensureRow2xbnpv1nvt_mi


! 
!  Return <code>true</code> iff the implementation sees
!  an incoming array satisfying condition I.
! 

subroutine IntO__isIMatrixOne3gwlgypfcv_mi(A, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixOne.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixOne.use)
  implicit none
  integer (selected_int_kind(18)) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixOne)
  logical isIMatrix
  retval = isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixOne)
end subroutine IntO__isIMatrixOne3gwlgypfcv_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming column-major array satisfying condition I.
! 

subroutine isColumnIMatrixOned9rdelopb9_mi(A, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixOne.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixOne.use)
  implicit none
  integer (selected_int_kind(18)) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixOne)
  logical acol, isIMatrix
  call SIDL_int__array_isColumnOrder_m(A, acol)
  retval = acol .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixOne)
end subroutine isColumnIMatrixOned9rdelopb9_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming row-major array satisfying condition I.
! 

subroutine I__isRowIMatrixOne607iplqtr5_mi(A, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixOne.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixOne.use)
  implicit none
  integer (selected_int_kind(18)) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixOne)
  logical arow, isIMatrix
  call SIDL_int__array_isRowOrder_m(A, arow)
  retval = arow .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixOne)
end subroutine I__isRowIMatrixOne607iplqtr5_mi


! 
!  Return <code>true</code> iff the implementation sees
!  an incoming array satisfying condition I.
! 

subroutine IntO__isIMatrixTwogo7_eewh9w_mi(A, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixTwo.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixTwo.use)
  implicit none
  integer (selected_int_kind(18)) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixTwo)
  logical isIMatrix
  retval = isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixTwo)
end subroutine IntO__isIMatrixTwogo7_eewh9w_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming column-major array satisfying condition I.
! 

subroutine isColumnIMatrixTwo9neer9_rft_mi(A, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixTwo.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixTwo.use)
  implicit none
  integer (selected_int_kind(18)) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixTwo)
  logical acol, isIMatrix
  call SIDL_int__array_isColumnOrder_m(A, acol)
  retval = acol .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixTwo)
end subroutine isColumnIMatrixTwo9neer9_rft_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming row-major array satisfying condition I.
! 

subroutine I__isRowIMatrixTwoqo0guawv83_mi(A, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixTwo.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixTwo.use)
  implicit none
  integer (selected_int_kind(18)) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixTwo)
  logical arow, isIMatrix
  call SIDL_int__array_isRowOrder_m(A, arow)
  retval = arow .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixTwo)
end subroutine I__isRowIMatrixTwoqo0guawv83_mi


! 
!  Return <code>true</code> iff the implementation sees
!  an incoming array satisfying condition I.
! 

subroutine Int__isIMatrixFourgf7n_6hyd2_mi(A, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixFour.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixFour.use)
  implicit none
  integer (selected_int_kind(18)) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixFour)
  logical isIMatrix
  retval = isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixFour)
end subroutine Int__isIMatrixFourgf7n_6hyd2_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming column-major array satisfying condition I.
! 

subroutine isColumnIMatrixFouunjqbwfb23_mi(A, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixFour.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixFour.use)
  implicit none
  integer (selected_int_kind(18)) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixFour)
  logical acol, isIMatrix
  call SIDL_int__array_isColumnOrder_m(A, acol)
  retval = acol .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixFour)
end subroutine isColumnIMatrixFouunjqbwfb23_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming row-major array satisfying condition I.
! 

subroutine __isRowIMatrixFourfai8pehvh9_mi(A, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixFour.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixFour.use)
  implicit none
  integer (selected_int_kind(18)) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixFour)
  logical arow, isIMatrix
  call SIDL_int__array_isRowOrder_m(A, arow)
  retval = arow .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixFour)
end subroutine __isRowIMatrixFourfai8pehvh9_mi


! 
! Return <code>true</code> iff the implementation of slice
! and smart copy is correct.
! 

subroutine In__isSliceWorkingf42w8d0h4b_mi(createCol, retval)
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isSliceWorking.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isSliceWorking.use)
  implicit none
  logical :: createCol
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isSliceWorking)
  integer*4 maxDim, halfDim, ind(2), stride(2), numElem(2)
  integer*4 newIndex(2), dimen, Aelem, Belem, iFunc
  integer*8 A, B
  retval = .true.
  maxDim = 16
  halfDim = maxDim / 2
  stride(1) = 2
  stride(2) = 2
  numElem(1) = halfDim
  numElem(2) = halfDim
  ind(1) = 0
  ind(2) = 0
  newIndex(1) = 0
  newIndex(2) = 0
  A = 0
  B = 0
  if (createCol) then
     call Ordering_IntOrderTest_makeColumnIMatrix_m(maxDim, .false., A)
  else
     call Ordering_IntOrderTest_makeRowIMatrix_m(maxDim, .false., A)
  endif
  call SIDL_int__array_slice_m(A, 2, numElem, ind, stride, newIndex, B)
  if (B .eq. 0) then 
     retval = .false.
     goto 100
  endif
  call SIDL_int__array_dimen_m(B, dimen)
  if (dimen .ne. 2) then
     retval = .false.
     goto 100
  endif

  do while (newIndex(2) .lt. halfDim)
     do while (newIndex(1) .lt. halfDim)
        call SIDL_int__array_get_m(A, ind, Aelem)
        call SIDL_int__array_get_m(B, newIndex, Belem)
        if ((Aelem .ne. Belem) .or.  Belem .ne. iFunc(ind, 2)) then
           retval = .false.
           goto 100
        endif
        newIndex(1) = newIndex(1) + 1
        ind(1) = ind(1) + 2
     enddo
     newIndex(2) = newIndex(2) + 1
     ind(2) = ind(2) + 2
  enddo

  ! CLEANUP AND RETURN
100 if (A .ne. 0) then
     call SIDL_int__array_deleteRef_m(A)
  endif
  if (B .ne. 0) then
     call SIDL_int__array_deleteRef_m(B)
  endif
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isSliceWorking)
end subroutine In__isSliceWorkingf42w8d0h4b_mi


! DO-NOT-DELETE splicer.begin(_miscellaneous_code_end)
! Insert extra code here...
! DO-NOT-DELETE splicer.end(_miscellaneous_code_end)
