// 
// File:          sort_IntegerContainer_Impl.cc
// Symbol:        sort.IntegerContainer-v0.1
// Symbol Type:   class
// Babel Version: 0.8.0
// Description:   Server-side implementation for sort.IntegerContainer
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.8.0
// 
#include "sort_IntegerContainer_Impl.hh"

// DO-NOT-DELETE splicer.begin(sort.IntegerContainer._includes)
#include <iostream>
// DO-NOT-DELETE splicer.end(sort.IntegerContainer._includes)

// user defined constructor
void sort::IntegerContainer_impl::_ctor() {
  // DO-NOT-DELETE splicer.begin(sort.IntegerContainer._ctor)
  // DO-NOT-DELETE splicer.end(sort.IntegerContainer._ctor)
}

// user defined destructor
void sort::IntegerContainer_impl::_dtor() {
  // DO-NOT-DELETE splicer.begin(sort.IntegerContainer._dtor)
  // DO-NOT-DELETE splicer.end(sort.IntegerContainer._dtor)
}

// user defined static methods: (none)

// user defined non-static methods:
/**
 * This sets the container size and pseudo-randomly orders the
 * Integer elements contained.
 */
void
sort::IntegerContainer_impl::setSize (
  /*in*/ int32_t size ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(sort.IntegerContainer.setSize)
  int32_t i, j;
  d_elements = SIDL::array<sort::Integer>::create1d(size);
  for(i = 0; i < size; ++i){
    sort::Integer intObj = sort::Integer::_create();
    intObj.setValue(i);
    d_elements.set(i, intObj);
  }
  for(i = size - 1; i > 0; --i) {
    j = random() % (i + 1);
    if (j != i) {
      self.swap(i, j);
    }
  }
  // DO-NOT-DELETE splicer.end(sort.IntegerContainer.setSize)
}

/**
 * Return the number of elements in the container.
 */
int32_t
sort::IntegerContainer_impl::size () 
throw () 

{
  // DO-NOT-DELETE splicer.begin(sort.IntegerContainer.size)
  return 1 + d_elements.upper(0) - d_elements.lower(0);
  // DO-NOT-DELETE splicer.end(sort.IntegerContainer.size)
}

/**
 * Return -1 if element i is less than element j, 0 if element i
 * is equal to element j, or otherwise 1.
 */
int32_t
sort::IntegerContainer_impl::compare (
  /*in*/ int32_t i,
  /*in*/ int32_t j,
  /*in*/ ::sort::Comparator comp ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(sort.IntegerContainer.compare)
  SIDL::BaseInterface i1(d_elements.get(i));
  SIDL::BaseInterface i2(d_elements.get(j));
  return comp.compare(i1, i2);
  // DO-NOT-DELETE splicer.end(sort.IntegerContainer.compare)
}

/**
 * Swap elements i and j.
 */
void
sort::IntegerContainer_impl::swap (
  /*in*/ int32_t i,
  /*in*/ int32_t j ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(sort.IntegerContainer.swap)
  const int32_t len = self.size();
  if (i >= 0 && j >= 0 && i < len && j < len) {
    sort::Integer 
      i1(d_elements.get(i)),
      i2(d_elements.get(j));
    d_elements.set(i, i2);
    d_elements.set(j, i1);
  }
  else {
    std::cerr << "sort::IntegerContainer::swap index out of bounds swap ("
	      << i << ", " << j << ") len (" << len << ")" << std::endl;
    exit(2);
  }
  // DO-NOT-DELETE splicer.end(sort.IntegerContainer.swap)
}

/**
 * Print elements s through e-1
 */
void
sort::IntegerContainer_impl::output (
  /*in*/ int32_t s,
  /*in*/ int32_t e ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(sort.IntegerContainer.output)
  std::cout << "COMMENT: list";
  while (s < e) {
    std::cout << ' ' << d_elements.get(s++).getValue();
  }
  std::cout << '\n';
  // DO-NOT-DELETE splicer.end(sort.IntegerContainer.output)
}


// DO-NOT-DELETE splicer.begin(sort.IntegerContainer._misc)
// Put miscellaneous code here
// DO-NOT-DELETE splicer.end(sort.IntegerContainer._misc)

