! 
! File:          sort_HeapSort_Impl.F90
! Symbol:        sort.HeapSort-v0.1
! Symbol Type:   class
! Babel Version: 0.8.0
! Description:   Server-side implementation for sort.HeapSort
! 
! WARNING: Automatically generated; only changes within splicers preserved
! 
! babel-version = 0.8.0
! 


! 
! Symbol "sort.HeapSort" (version 0.1)
! 
! Heap sort
! 


#include "sort_Counter_fAbbrev.h"
#include "sort_SortingAlgorithm_fAbbrev.h"
#include "sort_HeapSort_fAbbrev.h"
#include "SIDL_BaseInterface_fAbbrev.h"
#include "SIDL_BaseClass_fAbbrev.h"
#include "SIDL_ClassInfo_fAbbrev.h"
#include "sort_Comparator_fAbbrev.h"
#include "sort_Container_fAbbrev.h"
! DO-NOT-DELETE splicer.begin(_miscellaneous_code_start)
subroutine remakeHeap(elem, comp, cmp, swp, last, first)
  implicit none
  integer*8 elem, comp, cmp, swp
  integer*4 last, first, half, child, result, counter
  integer*4 f
  f = first
  half = (last/2) - 1
  do while (f .le. half) 
     child = f + f + 1
     if ((child + 1) .lt. last) then
        call sort_Counter_inc_m(cmp, counter)
        call sort_Container_compare_m(elem, child, child+1, &
             comp, result)
        if (result .lt. 0) then
           child = child + 1
        endif
     endif
     call sort_Counter_inc_m(cmp, counter)
     call sort_Container_compare_m(elem, f, child, comp, &
          result)
     if (result .ge. 0) goto 100
     call sort_Counter_inc_m(swp, counter)
     call sort_Container_swap_m(elem, f, child)
     f = child
  enddo
100 return
end subroutine remakeHeap
! DO-NOT-DELETE splicer.end(_miscellaneous_code_start)




! 
! Class constructor called when the class is created.
! 

subroutine sort_HeapSort__ctor_mi(self)
  ! DO-NOT-DELETE splicer.begin(sort.HeapSort._ctor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.HeapSort._ctor.use)
  implicit none
  integer (selected_int_kind(18)) :: self

! DO-NOT-DELETE splicer.begin(sort.HeapSort._ctor)
! Insert the implementation here...
! DO-NOT-DELETE splicer.end(sort.HeapSort._ctor)
end subroutine sort_HeapSort__ctor_mi


! 
! Class destructor called when the class is deleted.
! 

subroutine sort_HeapSort__dtor_mi(self)
  ! DO-NOT-DELETE splicer.begin(sort.HeapSort._dtor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.HeapSort._dtor.use)
  implicit none
  integer (selected_int_kind(18)) :: self

! DO-NOT-DELETE splicer.begin(sort.HeapSort._dtor)
! Insert the implementation here...
! DO-NOT-DELETE splicer.end(sort.HeapSort._dtor)
end subroutine sort_HeapSort__dtor_mi


! 
! Sort elements using Heap Sort.
! 

subroutine sort_HeapSort_sort_mi(self, elems, comp)
  ! DO-NOT-DELETE splicer.begin(sort.HeapSort.sort.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.HeapSort.sort.use)
  implicit none
  integer (selected_int_kind(18)) :: self
  integer (selected_int_kind(18)) :: elems
  integer (selected_int_kind(18)) :: comp

! DO-NOT-DELETE splicer.begin(sort.HeapSort.sort)
  integer*4 i, num, counter
  integer*8 cmp, swp
  call sort_Container_size_m(elems, num)
  call sort_HeapSort_getCompareCounter_m(self, cmp)
  call sort_HeapSort_getSwapCounter_m(self, swp)
!     make the heap
  do i = ((num / 2) - 1), 0, -1
     call remakeHeap(elems, comp, cmp, swp, num, i)
  enddo
!     put top of heap at back and remake the heap
  i = num - 1
  do while (i .gt. 0)
     call sort_Counter_inc_m(swp, counter)
     call sort_Container_swap_m(elems, 0, i)
     call remakeHeap(elems, comp, cmp, swp, i, 0)
     i = i - 1
  enddo
  call sort_Counter_deleteRef_m(cmp)
  call sort_Counter_deleteRef_m(swp)
! DO-NOT-DELETE splicer.end(sort.HeapSort.sort)
end subroutine sort_HeapSort_sort_mi


! 
! Return heap sort.
! 

subroutine sort_HeapSort_getName_mi(self, retval)
  ! DO-NOT-DELETE splicer.begin(sort.HeapSort.getName.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.HeapSort.getName.use)
  implicit none
  integer (selected_int_kind(18)) :: self
  character*(*) :: retval

! DO-NOT-DELETE splicer.begin(sort.HeapSort.getName)
  retval = 'Heap sort'
! DO-NOT-DELETE splicer.end(sort.HeapSort.getName)
end subroutine sort_HeapSort_getName_mi


! DO-NOT-DELETE splicer.begin(_miscellaneous_code_end)
! Insert extra code here...
! DO-NOT-DELETE splicer.end(_miscellaneous_code_end)
