! 
! File:          sort_QuickSort_Impl.F90
! Symbol:        sort.QuickSort-v0.1
! Symbol Type:   class
! Babel Version: 0.8.0
! Description:   Server-side implementation for sort.QuickSort
! 
! WARNING: Automatically generated; only changes within splicers preserved
! 
! babel-version = 0.8.0
! 


! 
! Symbol "sort.QuickSort" (version 0.1)
! 
! Quick sort
! 


#include "sort_Counter_fAbbrev.h"
#include "sort_SortingAlgorithm_fAbbrev.h"
#include "sort_QuickSort_fAbbrev.h"
#include "SIDL_BaseInterface_fAbbrev.h"
#include "SIDL_BaseClass_fAbbrev.h"
#include "SIDL_ClassInfo_fAbbrev.h"
#include "sort_Comparator_fAbbrev.h"
#include "sort_Container_fAbbrev.h"
! DO-NOT-DELETE splicer.begin(_miscellaneous_code_start)
#include "sort_MergeSort_fAbbrev.h"


logical function notEmpty(self)
  implicit none
  integer*8 self, stacks, depth
  integer*4 stackdepth
  call sort_QuickSort__get_data_m(self, stacks)
  call SIDL_opaque__array_get1_m(stacks, 0, depth)
  call SIDL_int__array_get1_m(depth, 0, stackdepth)
  notEmpty = (stackdepth .gt. 0)
end function notEmpty

subroutine push(self, lower, upper)
  integer*8 self
  integer*8 stacks, low, up, depth
  integer*4 lower, upper, stackdepth
  call sort_QuickSort__get_data_m(self, stacks)
  call SIDL_opaque__array_get1_m(stacks, 0, depth)
  call SIDL_opaque__array_get1_m(stacks, 1, low)
  call SIDL_opaque__array_get1_m(stacks, 2, up)
  call SIDL_int__array_get1_m(depth, 0, stackdepth)
  if (stackdepth .lt. 32) then
     call SIDL_int__array_set1_m(low, stackdepth, lower)
     call SIDL_int__array_set1_m(up, stackdepth, upper)
     stackdepth = stackdepth + 1
     call SIDL_int__array_set1_m(depth, 0, stackdepth)
  else
     write(*,*) 'ERROR: stack overflow in QuickSort'
     stop
  endif
end subroutine push

subroutine pop(self, lower, upper)
  integer*8 self
  integer*8 stacks, low, up, depth
  integer*4 lower, upper, stackdepth
  call sort_QuickSort__get_data_m(self, stacks)
  call SIDL_opaque__array_get1_m(stacks, 0, depth)
  call SIDL_opaque__array_get1_m(stacks, 1, low)
  call SIDL_opaque__array_get1_m(stacks, 2, up)
  call SIDL_int__array_get1_m(depth, 0, stackdepth)
  if (stackdepth .gt. 0) then
     stackdepth = stackdepth - 1
     call SIDL_int__array_set1_m(depth, 0, stackdepth)
     call SIDL_int__array_get1_m(low, stackdepth, lower)
     call SIDL_int__array_get1_m(up, stackdepth, upper)
  else
     write(*,*) 'ERROR: stack underflow in QuickSort'
     stop
  endif
end subroutine pop

!
! Choose the middle of the first, middle and last element of the
! list.  For small lists, return the middle without checking.
!
integer*4 function choosePivot(elems, comp, cmp, start, end)
  integer*8 elems, comp, cmp
  integer*4 start, end, pivot, mid, cmpres, counter
  pivot = (start + end) / 2
  if ((end - start) .gt. 4) then
     mid = pivot
     call sort_Counter_inc_m(cmp, counter)
     call sort_Container_compare_m(elems, start, mid, comp, cmpres)
     if (cmpres .le. 0) then
        call sort_Counter_inc_m(cmp, counter)
        call sort_Container_compare_m(elems, mid, end -1, comp, cmpres)
        if (cmpres .gt. 0) then
           call sort_Counter_inc_m(cmp, counter)
           call sort_Container_compare_m(elems, start, end - 1, comp, &
                cmpres)
           if (cmpres .lt. 0) then
              pivot = end - 1
           else
              pivot = start
           endif
        endif
     else
        call sort_Counter_inc_m(cmp, counter)
        call sort_Container_compare_m(elems, mid, end - 1, comp, cmpres)
        if (cmpres .lt. 0) then
           call sort_Counter_inc_m(cmp, counter)
           call sort_Container_compare_m(elems, start, end - 1, comp, &
                cmpres)
           if (cmpres .gt. 0) then
              pivot = end - 1
           else
              pivot = start
           endif
        endif
     endif
  endif
  choosePivot = pivot
end function choosePivot

subroutine quickSort(self, elems, comp, cmp, swp)
  integer*8 self, elems, comp, cmp, swp
  integer*4 start, end, pivot, choosePivot
  integer*4 i, j, cmpres
  logical notEmpty
  call sort_Container_size_m(elems, end)
  start = 0
  call push(self, start, end)
  do while (notEmpty(self))
     call pop(self, start, end)
     if ((end - start) .gt. 1) then
        pivot = choosePivot(elems, comp, cmp, start, end)
        i = start
        j = end
        if (pivot .ne. start) then
           call sort_Counter_inc_m(swp, counter)
           call sort_Container_swap_m(elems, start, pivot)
        endif
100     j = j - 1
        call sort_Counter_inc_m(cmp, counter)
        call sort_Container_compare_m(elems, start, j, comp, cmpres)
        if (cmpres .lt. 0) goto 100
        i = i + 1
        do while (i .lt. j)
           call sort_Counter_inc_m(cmp, counter)
           call sort_Container_compare_m(elems, start, i, comp, cmpres)
           if (cmpres .lt. 0) goto 200
           i = i + 1
        enddo
200     if (i .ge. j) goto 300
        call sort_counter_inc_m(swp, counter)
        call sort_Container_swap_m(elems, i, j)
        goto 100
300     if (j .ne. start) then
           call sort_Counter_inc_m(swp, counter)
           call sort_Container_swap_m(elems, start, j)
        endif
        call push(self, start, j)
        call push(self, j + 1, end)
     endif
  enddo
end subroutine quickSort

! DO-NOT-DELETE splicer.end(_miscellaneous_code_start)




! 
! Class constructor called when the class is created.
! 

subroutine sort_QuickSort__ctor_mi(self)
  ! DO-NOT-DELETE splicer.begin(sort.QuickSort._ctor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.QuickSort._ctor.use)
  implicit none
  integer (selected_int_kind(18)) :: self

! DO-NOT-DELETE splicer.begin(sort.QuickSort._ctor)
  integer*8 stacks, lower, upper, depth
  integer*4 stackdepth
  stackdepth = 0
  call SIDL_int__array_create1d_m(32, lower)
  call SIDL_int__array_create1d_m(32, upper)
  call SIDL_int__array_create1d_m(1, depth)
  call SIDL_int__array_set1_m(depth, 0, stackdepth)
  call SIDL_opaque__array_create1d_m(3, stacks)
  call SIDL_opaque__array_set1_m(stacks, 0, depth)
  call SIDL_opaque__array_set1_m(stacks, 1, lower)
  call SIDL_opaque__array_set1_m(stacks, 2, upper)
  call sort_QuickSort__set_data_m(self, stacks)
! DO-NOT-DELETE splicer.end(sort.QuickSort._ctor)
end subroutine sort_QuickSort__ctor_mi


! 
! Class destructor called when the class is deleted.
! 

subroutine sort_QuickSort__dtor_mi(self)
  ! DO-NOT-DELETE splicer.begin(sort.QuickSort._dtor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.QuickSort._dtor.use)
  implicit none
  integer (selected_int_kind(18)) :: self

! DO-NOT-DELETE splicer.begin(sort.QuickSort._dtor)
  integer*8 stacks, lower, upper, depth
  call sort_QuickSort__get_data_m(self, stacks)
  call SIDL_opaque__array_get1_m(stacks, 0, depth)
  call SIDL_opaque__array_get1_m(stacks, 1, lower)
  call SIDL_opaque__array_get1_m(stacks, 2, upper)
  call SIDL_int__array_deleteRef_m(depth)
  call SIDL_int__array_deleteRef_m(lower)
  call SIDL_int__array_deleteRef_m(upper)
  call SIDL_opaque__array_deleteRef_m(stacks)
  stacks = 0
  call sort_QuickSort__set_data_m(self, stacks)
! DO-NOT-DELETE splicer.end(sort.QuickSort._dtor)
end subroutine sort_QuickSort__dtor_mi


! 
! Sort elements using Quick Sort.
! 

subroutine sort_QuickSort_sort_mi(self, elems, comp)
  ! DO-NOT-DELETE splicer.begin(sort.QuickSort.sort.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.QuickSort.sort.use)
  implicit none
  integer (selected_int_kind(18)) :: self
  integer (selected_int_kind(18)) :: elems
  integer (selected_int_kind(18)) :: comp

! DO-NOT-DELETE splicer.begin(sort.QuickSort.sort)
  integer*8 swp, cmp
  call sort_MergeSort_getCompareCounter_m(self, cmp)
  call sort_MergeSort_getSwapCounter_m(self, swp)
  call quickSort(self, elems, comp, cmp, swp)
  call sort_Counter_deleteRef_m(cmp)
  call sort_Counter_deleteRef_m(swp)
! DO-NOT-DELETE splicer.end(sort.QuickSort.sort)
end subroutine sort_QuickSort_sort_mi


! 
! Return quick sort.
! 

subroutine sort_QuickSort_getName_mi(self, retval)
  ! DO-NOT-DELETE splicer.begin(sort.QuickSort.getName.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.QuickSort.getName.use)
  implicit none
  integer (selected_int_kind(18)) :: self
  character*(*) :: retval

! DO-NOT-DELETE splicer.begin(sort.QuickSort.getName)
  retval = 'Quick sort'
! DO-NOT-DELETE splicer.end(sort.QuickSort.getName)
end subroutine sort_QuickSort_getName_mi


! DO-NOT-DELETE splicer.begin(_miscellaneous_code_end)
! Insert extra code here...
! DO-NOT-DELETE splicer.end(_miscellaneous_code_end)
