! 
! File:          sort_SortTest_Impl.F90
! Symbol:        sort.SortTest-v0.1
! Symbol Type:   class
! Babel Version: 0.8.0
! Description:   Server-side implementation for sort.SortTest
! 
! WARNING: Automatically generated; only changes within splicers preserved
! 
! babel-version = 0.8.0
! 


! 
! Symbol "sort.SortTest" (version 0.1)
! 
! Run a bunch of sorts through a stress test.
! 


#include "sort_SortingAlgorithm_fAbbrev.h"
#include "SIDL_BaseInterface_fAbbrev.h"
#include "SIDL_BaseClass_fAbbrev.h"
#include "SIDL_ClassInfo_fAbbrev.h"
#include "sort_SortTest_fAbbrev.h"
! DO-NOT-DELETE splicer.begin(_miscellaneous_code_start)
#include "sort_CompInt_fAbbrev.h"
#include "sort_Container_fAbbrev.h"
#include "sort_Counter_fAbbrev.h"
#include "sort_IntegerContainer_fAbbrev.h"

subroutine sortAndReport(alg, cont, comp)
  implicit none
  integer*8 alg, cont, comp
  integer*8 swpCnt, cmpCnt
  integer*4 numswap, numcmp
  call sort_SortingAlgorithm_reset_m(alg)
  call sort_SortingAlgorithm_sort_m(alg, cont, comp)
  call sort_SortingAlgorithm_getSwapCounter_m(alg, swpCnt)
  call sort_Counter_getCount_m(swpCnt, numswap)
  call sort_Counter_deleteRef_m(swpCnt)
  call sort_SortingAlgorithm_getCompareCounter_m(alg, cmpCnt)
  call sort_Counter_getCount_m(cmpCnt, numcmp)
  call sort_Counter_deleteRef_m(cmpCnt)
  write (*,*) 'COMMENT: compares (', numcmp, ') swaps (', numswap, ')'
end subroutine sortAndReport

logical function notSorted(cont, comp)
  implicit none
  integer*8 cont, comp
  integer*4 size, i, result
  call sort_Container_size_m(cont, size)
  do i = 1, size - 1
     call sort_Container_compare_m(cont, i-1, i, comp, result)
     if (result .gt. 0) then
        notSorted = .true.
        goto 100
     endif
  enddo
  notSorted = .false.
100 return
end function notSorted

subroutine testAlgorithm(alg, retval)
  implicit none
  integer*8 alg
  integer*8 data, cont, intcomp, comp
  character*30 name
  logical notSorted, retval
  integer*4 j, testsizes(10)
  data testsizes / 0, 1, 2, 3, 4, 7, 10, 51, 100, -1 /

  call sort_SortingAlgorithm_getName_m(alg, name)
  write(*,*) 'COMMENT: ****ALGORITHM IS ' // name // '****'
  call sort_IntegerContainer__create_m(data)
  call sort_IntegerContainer__cast_m(data, 'sort.Container', cont)
  call sort_CompInt__create_m(intcomp)
  call sort_CompInt__cast_m(intcomp, 'sort.Comparator', comp)
  j = 1
  do while (testsizes(j) .ge. 0)
     call sort_CompInt_setSortIncreasing_m(intcomp, .true.)
     write (*,*) 'COMMENT: DATA SIZE ', testsizes(j)
     call sort_IntegerContainer_setSize_m(data, testsizes(j))
     call sortAndReport(alg, cont, comp)
     if (notSorted(cont, comp)) then
        write(*,*) 'COMMENT: sort failed!!'
        retval = .false.
     endif
     write (*, *) 'COMMENT: pre-sorted list'
     call sortAndReport(alg, cont, comp)
     if (notSorted(cont, comp)) then
        write(*,*) 'COMMENT: sort failed!!'
        retval = .false.
     endif
     write (*, *) 'COMMENT: reverse sorted list'
     call sort_CompInt_setSortIncreasing_m(intcomp, .false.)
     call sortAndReport(alg, cont, comp)
     if (notSorted(cont, comp)) then
        write(*,*) 'COMMENT: sort failed!!'
        retval = .false.
     endif
     j = j + 1
  enddo

  call sort_IntegerContainer_deleteRef_m(data)
  call sort_SortingAlgorithm_deleteRef_m(alg)
  call sort_CompInt_deleteRef_m(intcomp)
end subroutine testAlgorithm
! DO-NOT-DELETE splicer.end(_miscellaneous_code_start)




! 
! Class constructor called when the class is created.
! 

subroutine sort_SortTest__ctor_mi(self)
  ! DO-NOT-DELETE splicer.begin(sort.SortTest._ctor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.SortTest._ctor.use)
  implicit none
  integer (selected_int_kind(18)) :: self

! DO-NOT-DELETE splicer.begin(sort.SortTest._ctor)
! Insert the implementation here...
! DO-NOT-DELETE splicer.end(sort.SortTest._ctor)
end subroutine sort_SortTest__ctor_mi


! 
! Class destructor called when the class is deleted.
! 

subroutine sort_SortTest__dtor_mi(self)
  ! DO-NOT-DELETE splicer.begin(sort.SortTest._dtor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.SortTest._dtor.use)
  implicit none
  integer (selected_int_kind(18)) :: self

! DO-NOT-DELETE splicer.begin(sort.SortTest._dtor)
! Insert the implementation here...
! DO-NOT-DELETE splicer.end(sort.SortTest._dtor)
end subroutine sort_SortTest__dtor_mi


! 
! Perform the array stress test.
! 
! Return true if all the algorithms work okay.
! 

subroutine sort_SortTest_stressTest_mi(algs, retval)
  ! DO-NOT-DELETE splicer.begin(sort.SortTest.stressTest.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(sort.SortTest.stressTest.use)
  implicit none
  integer (selected_int_kind(18)) :: algs
  logical :: retval

! DO-NOT-DELETE splicer.begin(sort.SortTest.stressTest)
  integer*4 lower, upper, i
  integer*8 alg
  if (algs .ne. 0) then
     call sort_SortingAlgorithm__array_lower_m(algs, 0, lower)
     call sort_SortingAlgorithm__array_upper_m(algs, 0, upper)
     retval = .true.
     do i = lower, upper
        call sort_SortingAlgorithm__array_get1_m(algs, i, alg)
        if (alg .ne. 0) then
           call testAlgorithm(alg, retval)
        else
           retval = .false.
        endif
     enddo
  endif
! DO-NOT-DELETE splicer.end(sort.SortTest.stressTest)
end subroutine sort_SortTest_stressTest_mi


! DO-NOT-DELETE splicer.begin(_miscellaneous_code_end)
! Insert extra code here...
! DO-NOT-DELETE splicer.end(_miscellaneous_code_end)
